/*
 * semaphores.c
 *
 *  Created on: Aug 3, 2014
 *      Author: andreas
 */

#include "semaphores.h"

int32_t sem_id;

void setup_semaphores()
{
	srand(time(NULL));
	key_t key = rand();

	int try = 0;
	while (try < 3 && (sem_id = semget( key, SEMAPHORES_COUNT, IPC_CREAT | IPC_EXCL | 0666)) < 0)
	{
		key = rand();
		try++;
	}

	if(sem_id < 0)
	{
		printf("SIM_ERROR: Couldn't allocate semaphores.\n");
		main_exit(1);
	}

	union semun semopts;
	semopts.val = 1;

	int i;
	for(i=0; i<SEMAPHORES_COUNT; ++i)
	{
		if(semctl( sem_id, 0, SETVAL, semopts) == -1)
		{
			printf("SIM_ERROR: Couldn't set semaphore %d.\n", i);
			main_exit(1);
		}
	}
}

void lock_semaphore(unsigned short sem_num)
{
	static struct sembuf semaphore;
	semaphore.sem_num = sem_num;
	semaphore.sem_op = -1; //lock
   	semaphore.sem_flg = SEM_UNDO;

	if( semop (sem_id, &semaphore, 1) == -1) {
		printf("SIM_ERROR: Couldn't lock semaphore %d.\n", sem_num);
		main_exit(1);
   	}
}

void unlock_semaphore(unsigned short sem_num)
{
	static struct sembuf semaphore;
	semaphore.sem_num = sem_num;
	semaphore.sem_op = 1; //unlock
   	semaphore.sem_flg = SEM_UNDO;

	if( semop (sem_id, &semaphore, 1) == -1) {
		printf("SIM_ERROR: Couldn't allocate semaphore %d.\n", sem_num);
		main_exit(1);
   	}
}

void release_semaphores()
{
	if(semctl (sem_id, 0, IPC_RMID, 0) < 0)
	{
		printf("SIM_ERROR: Couldn't release semaphores.\n");
	}
	else
	{
		printf("SIM_INFO: Semaphores released.\n");
	}
}
