/*
 * ipc.c
 *
 *  Created on: Aug 10, 2014
 *      Author: andreas
 */

#include "station_ipc.h"

int mq_sim2sta[SIM_STATION_COUNT];
int mq_sta2sim[SIM_STATION_COUNT];

void init_ipc()
{
	int i;
	for(i=0; i<SIM_STATION_COUNT; ++i)
	{
		if((mq_sim2sta[i] = msgget(IPC_PRIVATE, IPC_CREAT | IPC_EXCL | 0666)) < 0)
		{
			printf("msgget sim2sta %d failed.\n", mq_sim2sta[i]);
		}

		if((mq_sta2sim[i] = msgget(IPC_PRIVATE, IPC_CREAT | IPC_EXCL | 0666)) < 0)
		{
			printf("msgget sta2sim %d failed.\n", mq_sta2sim[i]);
		}

		printf("msg queues: (%3d,%3d) ", mq_sim2sta[i], mq_sta2sim[i]);
	}
	printf("\n");
}

void release_ipc()
{
	int i;
	for(i=0; i<SIM_STATION_COUNT; ++i)
	{
		if(msgctl (mq_sim2sta[i], IPC_RMID, NULL) < 0)
		{
			printf("msgctl IPC_RMID sim2sta %d failed.\n", mq_sim2sta[i]);
		}

		if(msgctl (mq_sta2sim[i], IPC_RMID, NULL) < 0)
		{
			printf("msgctl IPC_RMID sta2sim %d failed.\n", mq_sta2sim[i]);
		}
	}
}
