/*
 * statistics.c
 *
 *  Created on: Aug 18, 2014
 *      Author: andreas
 */

#include "statistics.h"

static void close_window (void)
{
	gtk_main_quit ();
}

void statistics_signal_handler(int signal);

GtkTextBuffer **text_buffers;
GtkWidget **text_views;


static gboolean time_handler(GtkWidget *widget)
{
	int i;

	for(i = 0; i<SIM_STATION_COUNT; ++i)
	{
		char buf[1000];
		int sum;

		gtk_text_buffer_set_text(GTK_TEXT_BUFFER (text_buffers[i]), buf, 0);

		GtkTextIter iter;
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "State Transition Matrix:\n"));
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "     B      F      O      J      M      SO     I      SE     R\n"));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "B  "));
		int j;
		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[0][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));


		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "F  "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[1][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));


		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "O  "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[2][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));




		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "J  "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[3][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));




		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "M  "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[4][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));




		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "SO "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[5][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));




		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "I  "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[6][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "SE "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[7][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n"));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "R  "));

		for(j=0; j<9; j++)
		{
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].state_transition_matrix[8][j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n\n"));


		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Recoveries:\n  Same Ring:       %6d\n  Successor Ring:  %6d\n  Bridged:         %6d\n  Inconsistent:    %6d\n  Timeout:         %6d\n  Double Pickup:   %6d\n\n", l_stats[i].recoveries[0],l_stats[i].recoveries[1],l_stats[i].recoveries[2],l_stats[i].recoveries[3],l_stats[i].recoveries[4],l_stats[i].recoveries[5]));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Token acked:\n"));


		sum = 0;
		for(j=0; j<10; j++)
		{
			sum += l_stats[i].token_ack[j];
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].token_ack[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Token implicitly acked:\n"));

		sum = 0;
		for(j=0; j<10; j++)
		{
			sum += l_stats[i].token_impl_ack[j];
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].token_impl_ack[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
				gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Token failed: %d\n\n", l_stats[i].token_pass_fails));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Token received with FinalToken:\n"));

		sum = 0;
		for(j=0; j<10; j++)
		{
			sum += l_stats[i].token_received_w_ft[j];
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].token_received_w_ft[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Token received without FinalToken:\n"));

		sum = 0;
		for(j=0; j<10; j++)
		{
			sum += l_stats[i].token_received_wo_ft[j];
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].token_received_wo_ft[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
				gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "FT overheard: %d\n\n", l_stats[i].ft_overheard));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Payloads created: %d\n\n", l_stats[i].pl_created));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Packets sent: %d\n\n", l_stats[i].packets_sent));


		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Packets acked:\n"));

		sum = l_stats[i].data_ack[j];
		for(j=0; j<10; j++)
		{
			sum += 0;
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].data_ack[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Payloads failed: %d\n\n", l_stats[i].data_fails[j]));


		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Packets received - good payload:\n"));

		sum = l_stats[i].data_rcvd_good_pl[j];
		for(j=0; j<10; j++)
		{
			sum += 0;
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].data_rcvd_good_pl[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Packets received - bad payload:\n"));

		sum = 0;
		for(j=0; j<10; j++)
		{
			sum += l_stats[i].data_rcvd_bad_pl[j];
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].data_rcvd_bad_pl[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Rings created: %d\n\n", l_stats[i].rings_created));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Token created: %d\n\n", l_stats[i].token_created));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Rejoins: %d\n\n", l_stats[i].rejoins));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Rotations: %d\n\n", l_stats[i].rotations));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Bad Headers: %d\n\n", l_stats[i].bad_header));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Idle Timer fired: %d\n\n", l_stats[i].idle_timer_fired));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "Token Lifetime (Rotations):\n"));

		sum = 0;
		for(j=0; j<21; j++)
		{
			sum += l_stats[i].token_lifetimes[j];
			gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
			gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "%6d ", l_stats[i].token_lifetimes[j]));
		}
		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "\n = %d\n\n", sum));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "> 20: %d\n",l_stats[i].token_lifetimes[21]));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "> 100:: %d\n",l_stats[i].token_lifetimes[22]));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "> 1000: %d\n",l_stats[i].token_lifetimes[23]));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "> 10000: %d\n",l_stats[i].token_lifetimes[24]));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "> 100000: %d\n",l_stats[i].token_lifetimes[25]));

		gtk_text_buffer_get_end_iter (GTK_TEXT_BUFFER (text_buffers[i]), &iter);
		gtk_text_buffer_insert (GTK_TEXT_BUFFER (text_buffers[i]), &iter, buf, snprintf(buf, 1000, "> 100000: %d\n",l_stats[i].token_lifetimes[26]));



}

	return TRUE;
}

int statistics_main()
{
	struct sigaction action;
	memset(&action, 0, sizeof(struct sigaction));
	action.sa_handler = statistics_signal_handler;
	sigaction(SIGTERM, &action, NULL);
	sigaction(SIGINT, &action, NULL);
	sigaction(SIGQUIT, &action, NULL);
	sigaction(SIGHUP, &action, NULL);

	printf("STATS_INFO: Hello World!!!\n");

	GtkWidget *window;
	GtkWidget *frame;

	GtkWidget **scrolled_windows;
	GtkWidget *box;


	int i;

	gtk_init(NULL, NULL);

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "Statistics");
	gtk_window_set_default_size(GTK_WINDOW (window), 400, 600);

	g_signal_connect (window, "destroy", G_CALLBACK (close_window), NULL);

	gtk_container_set_border_width (GTK_CONTAINER (window), 8);

	frame = gtk_frame_new (NULL);
	gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
	gtk_container_add (GTK_CONTAINER (window), frame);

	box = gtk_box_new(GTK_ORIENTATION_HORIZONTAL, 5);
	gtk_box_set_homogeneous (GTK_BOX (box), TRUE);

	text_views = malloc(SIM_STATION_COUNT * sizeof(GtkWidget*));
	scrolled_windows = malloc(SIM_STATION_COUNT * sizeof(GtkWidget*));
	text_buffers = malloc(SIM_STATION_COUNT * sizeof(GtkTextBuffer*));



	for(i = 0; i<SIM_STATION_COUNT; ++i)
	{
		text_views[i] = gtk_text_view_new ();
		gtk_text_view_set_editable (GTK_TEXT_VIEW (text_views[i]), FALSE);

		PangoFontDescription *font_desc;
		font_desc = pango_font_description_from_string ("monospace 7");
		gtk_widget_override_font (text_views[i], font_desc);
		pango_font_description_free (font_desc);

		scrolled_windows[i] = gtk_scrolled_window_new (NULL, NULL);
		text_buffers[i] = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text_views[i]));

		//gtk_text_buffer_set_text (GTK_TEXT_BUFFER (text_buffers[i]), "Hello, this is some text", -1);


		gtk_box_pack_start(GTK_BOX (box), scrolled_windows[i], TRUE, TRUE, 0);

		gtk_container_add(GTK_CONTAINER (scrolled_windows[i]), text_views[i]);
	}


	/* set a minimum size */


	gtk_container_add (GTK_CONTAINER (frame), box);



	/* Signals used to handle the backing surface */
	/*g_signal_connect (da, "draw",
					G_CALLBACK (draw_cb), NULL);
	g_signal_connect (da,"configure-event",
					G_CALLBACK (configure_event_cb), NULL);

	g_signal_connect (da, "button-press-event",
	                    G_CALLBACK (button_press_event_cb), NULL);

	g_signal_connect (da, "button-release-event",
		                    G_CALLBACK (button_release_event_cb), NULL);

	g_signal_connect (da, "scroll-event",
			                    G_CALLBACK (scroll_event_cb), NULL);

	g_signal_connect (da, "motion-notify-event",
				                    G_CALLBACK (motion_notify_event_cb), NULL);

	gtk_widget_set_events (da, gtk_widget_get_events (da)
	                             | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_SCROLL_MASK | GDK_POINTER_MOTION_MASK);
*/
	gtk_widget_show_all (window);

	g_timeout_add(1000, (GSourceFunc) time_handler, (gpointer) window);

	//g_timeout_add(100, (GSourceFunc) time_handler, (gpointer) window);

	gtk_main ();

	/*while(1)
	{
		int nread;
		char buf[PIPE_BUF];

		if ((nread = read(uart_read_fds[0], buf, PIPE_BUF)) > 0)
		{
			printf("%s\n", buf);
		}
	}*/

	return 0;
}

void statistics_signal_handler(int signal)
{
	const char *signal_name;

	switch (signal) {
		case SIGTERM:
			signal_name = "SIGTERM";
			break;
		case SIGQUIT:
			signal_name = "SIGQUIT";
			break;
		case SIGINT:
			signal_name = "SIGINT";
			break;
		case SIGHUP:
			signal_name = "SIGHUP";
			break;
		default:
			signal_name = "UNKNOWN_SIGNAL";
			break;
	}

	printf("STATS_INFO: Received %s, exiting...\n", signal_name);

	exit(0);
}
