/**
 * @file	debug.h
 * @author	Christian
 * @date	30.03.2011
 * @brief	Debug Header File
 *
 * Last Change Base: 		$LastChangedRevision: 116 $
 * Last Changed By: 		$LastChangedBy: cd185990 $
 * Last Changed On: 		$LastChangedDate: 2011-06-07 19:06:13 +0200 (Tue, 07 Jun 2011) $
 *
 * Copyright: 2009 - 2011, Mobile Network Performance Group, RWTH Aachen
 */

#ifndef DEBUG_H_
#define DEBUG_H_

#include <stdio.h>
#include <string.h>
#include <stdarg.h>

#define DBG_NOTSET	0
#define DBG_MSG		1
#define DBG_ALL		DBG_MSG
#define DBG_INFO	2
#define DBG_NOTICE	3
#define DBG_WARN	4
#define DBG_CRIT	6
#define	DBG_FATAL	8


#ifdef DEBUG
	#define	debug(lvl, fmt, ...) \
		do { if ( lvl >= DEBUG_MSGLEVEL) xil_printf("[%d] %s() @ %d: " fmt, \
		lvl, __func__, __LINE__, __VA_ARGS__);} while(0)
#else
	#define	debug(lvl,...) \
		do {if (0) xil_printf(__VA_ARGS__,lvl);} while(0)
#endif


//#if defined(NDEBUG) && defined(__GNUC__)
/* gcc's cpp has extensions; it allows for macros with a variable number of
   arguments. We use this extension here to preprocess debug away. */
//#define debug(level, format, args...) ((void)0)
//#else
//void debug(unsigned int level, char *format, ...);
//#endif

#endif /* DEBUG_H_ */
