/**
 * @file	mnp.c
 * @author	cd185990
 * @date	2010/06/26
 * @brief	MNP Group Declaration / Interface File
 *
 * Last Change Base: 		$LastChangedRevision: 444 $
 * Last Changed By: 		$LastChangedBy: cd185990 $
 * Last Changed On: 		$LastChangedDate: 2014-02-14 12:23:46 +0100 (Fri, 14 Feb 2014) $
 *
 * Copyright: 2010 - 2014, Mobile Network Performance Group, RWTH Aachen
 */

#include "mnp.h"

/*#include "xbasic_types.h"
#include "xstatus.h"
#include "xio.h"
#include "xgpio.h"*/

//char timers[8] = {0,0,0,0,0,0,0,0};

/* ********************************************
 * Timer functions
 *********************************************/
// Highlevel functions
int	mnp_timer_set(unsigned char timer, unsigned int length) {
	warp_timer_setTimer(timer, 0, (length*TIMERCLK_CYCLES_PER_USEC)); // length given in us
	warp_timer_setMode(timer, TIMER_MODE_NOCARRIERSENSE);
	warp_timer_start(timer);
//	timers[timer%8] = 1;

	return CALLBACK_OK;
}

int mnp_timer_pause(unsigned char timer) {
	warp_timer_pause(timer);
//	if (!mnp_timer_isPaused(timer)) {
//		warp_timer_resume(timer);
//		warp_timer_pause(timer);
//	}

	return CALLBACK_OK;
}

int mnp_timer_resume(unsigned char timer) {
	warp_timer_resume(timer);

	return CALLBACK_OK;
}

int	mnp_timer_remove(unsigned char timer) {
	warp_timer_pause(timer);
	warp_timer_resetDone(timer);
	warp_timer_setTimer(timer,0,0);
	warp_timer_resume(timer);
//	timers[timer%8] = 0;
//	usleep(1);

	return CALLBACK_OK;
}

unsigned char mnp_timer_isActive(unsigned char timer) {
	return warp_timer_isActive(timer);// && timers[timer%8];
}

unsigned char mnp_timer_isDone(unsigned char timer) {
	return warp_timer_isDone(timer);// && !timers[timer%8];
}

unsigned char mnp_timer_isPaused(unsigned char timer) {
	return warp_timer_isPaused(timer);// && !timers[timer%8];
}

/* ********************************************
 * DebugGPIO functions
 *********************************************/
unsigned char mnp_gpiovalue = 0;

void	mnp_debuggpio_set(unsigned char val) {
	mnp_gpiovalue = mnp_gpiovalue | val;
	warpmac_setDebugGPIO(mnp_gpiovalue,0);
}

void	mnp_debuggpio_unset(unsigned char val) {
	mnp_gpiovalue = mnp_gpiovalue & ~val;
	warpmac_setDebugGPIO(mnp_gpiovalue,0);
}

#ifdef XPAR_MNP_GPIOCONNECT_PLBW_NUM_INSTANCES
unsigned char mnp_debuggpio_get() {
	printf("mnp_debuggpio_get() not implemented.\n");
	//return XIo_In32(XPAR_MNP_GPIOCONNECT_PLBW_0_MEMMAP_MNP_GPIOCONNECT_IN_REG);
	return 0;
}
#endif

/* ********************************************
 * Counter functions
 *********************************************/
#ifdef XPAR_MNP_COUNTER_PLBW_NUM_INSTANCES

// Hardware interface
/*#define mnp_counter_WriteReg_config(c) XIo_Out32(XPAR_MNP_COUNTER_PLBW_0_MEMMAP_COUNTER_CONFIG, (unsigned char)(c))
#define mnp_counter_ReadReg_config() XIo_In32(XPAR_MNP_COUNTER_PLBW_0_MEMMAP_COUNTER_CONFIG)

#define mnp_counter_ReadReg_value_high() XIo_In32(XPAR_MNP_COUNTER_PLBW_0_MEMMAP_COUNTER_VALUE_H)
#define mnp_counter_ReadReg_value_low() XIo_In32(XPAR_MNP_COUNTER_PLBW_0_MEMMAP_COUNTER_VALUE_L)*/

// Low-level functions
void	mnp_counter_enable() {
	printf("mnp_counter_enable() not implemented.\n");
	//mnp_counter_WriteReg_config(mnp_counter_ReadReg_config() | MNP_COUNTER_ENABLE_BIT);
}

void	mnp_counter_disable() {
	printf("mnp_counter_disable() not implemented.\n");
	//mnp_counter_WriteReg_config(mnp_counter_ReadReg_config() & ~MNP_COUNTER_ENABLE_BIT);
}

void	mnp_counter_reset() {
	printf("mnp_counter_reset() not implemented.\n");
	mnp_counter_disable();
	//mnp_counter_WriteReg_config(mnp_counter_ReadReg_config() | MNP_COUNTER_RESET_BIT);
	//mnp_counter_WriteReg_config(mnp_counter_ReadReg_config() & ~MNP_COUNTER_RESET_BIT);
}

// High-level functions
void mnp_counter_start() {
	mnp_counter_reset();
	mnp_counter_enable();
}

unsigned long long mnp_counter_stop() {
	mnp_counter_disable();
	return mnp_counter_getValue();
}

unsigned long long mnp_counter_getValue() {
	printf("mnp_counter_getValue() not implemented.\n");
	//unsigned long long value = mnp_counter_ReadReg_value_high();
	//value = (value << 32) | (unsigned long long)mnp_counter_ReadReg_value_low();
	//return value;
	return 0;
}
#endif
