/*
 * console.c
 *
 *  Created on: Aug 7, 2014
 *      Author: andreas
 */

#include "console.h"

static void close_window (void)
{
	gtk_main_quit ();
}

//int console_count;

void console_signal_handler(int signal);

GtkTextBuffer **text_buffers;
GtkWidget **text_views;

static gboolean time_handler(GtkWidget *widget)
{
	int nread;
	char	buf[PIPE_BUF];

	int i;
	for(i=0; i<SIM_STATION_COUNT; ++i)
	{
		if ((nread = read(uart_read_fds[i], buf, PIPE_BUF)) > 0)
		{
			GtkTextIter iter;
			gtk_text_buffer_get_end_iter (text_buffers[i], &iter);
			gtk_text_buffer_insert (text_buffers[i], &iter, buf, nread);
			gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(text_views[i]),
			gtk_text_buffer_get_insert(text_buffers[i]), 0.0, TRUE, 0.5, 0.5);
		}
		else
		{
			/*GtkTextIter iter;
			gtk_text_buffer_get_end_iter (text_buffers[i], &iter);
			gtk_text_buffer_insert (text_buffers[i], &iter, "n\n", 2);
			gtk_text_view_scroll_to_mark(GTK_TEXT_VIEW(text_views[i]),
			gtk_text_buffer_get_insert(text_buffers[i]), 0.0, TRUE, 0.5, 0.5);*/

		}
	}

	return TRUE;
}

int console_main()
{
	struct sigaction action;
	memset(&action, 0, sizeof(struct sigaction));
	action.sa_handler = console_signal_handler;
	sigaction(SIGTERM, &action, NULL);
	sigaction(SIGINT, &action, NULL);
	sigaction(SIGQUIT, &action, NULL);
	sigaction(SIGHUP, &action, NULL);

	printf("CONSOLE_INFO: Hello World!!!\n");

	GtkWidget *window;
	GtkWidget *frame;

	GtkWidget **scrolled_windows;
	GtkWidget *box;


	int i;

	gtk_init(NULL, NULL);

	window = gtk_window_new (GTK_WINDOW_TOPLEVEL);
	gtk_window_set_title (GTK_WINDOW (window), "Console");
	gtk_window_set_default_size(GTK_WINDOW (window), 800, 600);

	g_signal_connect (window, "destroy", G_CALLBACK (close_window), NULL);

	gtk_container_set_border_width (GTK_CONTAINER (window), 8);

	frame = gtk_frame_new (NULL);
	gtk_frame_set_shadow_type (GTK_FRAME (frame), GTK_SHADOW_IN);
	gtk_container_add (GTK_CONTAINER (window), frame);

	box = gtk_box_new(GTK_ORIENTATION_VERTICAL, 5);
	gtk_box_set_homogeneous (GTK_BOX (box), TRUE);

	text_views = malloc(SIM_STATION_COUNT * sizeof(GtkWidget*));
	scrolled_windows = malloc(SIM_STATION_COUNT * sizeof(GtkWidget*));
	text_buffers = malloc(SIM_STATION_COUNT * sizeof(GtkTextBuffer*));


	for(i = 0; i<SIM_STATION_COUNT; ++i)
	{
		text_views[i] = gtk_text_view_new ();
		gtk_text_view_set_editable (GTK_TEXT_VIEW (text_views[i]), FALSE);

		scrolled_windows[i] = gtk_scrolled_window_new (NULL, NULL);
		text_buffers[i] = gtk_text_view_get_buffer (GTK_TEXT_VIEW (text_views[i]));

		//gtk_text_buffer_set_text (GTK_TEXT_BUFFER (text_buffers[i]), "Hello, this is some text", -1);


		gtk_box_pack_start(GTK_BOX (box), scrolled_windows[i], TRUE, TRUE, 0);

		gtk_container_add(GTK_CONTAINER (scrolled_windows[i]), text_views[i]);
	}


	/* set a minimum size */


	gtk_container_add (GTK_CONTAINER (frame), box);



	/* Signals used to handle the backing surface */
	/*g_signal_connect (da, "draw",
					G_CALLBACK (draw_cb), NULL);
	g_signal_connect (da,"configure-event",
					G_CALLBACK (configure_event_cb), NULL);

	g_signal_connect (da, "button-press-event",
	                    G_CALLBACK (button_press_event_cb), NULL);

	g_signal_connect (da, "button-release-event",
		                    G_CALLBACK (button_release_event_cb), NULL);

	g_signal_connect (da, "scroll-event",
			                    G_CALLBACK (scroll_event_cb), NULL);

	g_signal_connect (da, "motion-notify-event",
				                    G_CALLBACK (motion_notify_event_cb), NULL);

	gtk_widget_set_events (da, gtk_widget_get_events (da)
	                             | GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK | GDK_SCROLL_MASK | GDK_POINTER_MOTION_MASK);
*/
	gtk_widget_show_all (window);

	g_timeout_add(100, (GSourceFunc) time_handler, (gpointer) window);

	//g_timeout_add(100, (GSourceFunc) time_handler, (gpointer) window);

	gtk_main ();

	/*while(1)
	{
		int nread;
		char buf[PIPE_BUF];

		if ((nread = read(uart_read_fds[0], buf, PIPE_BUF)) > 0)
		{
			printf("%s\n", buf);
		}
	}*/

	return 0;
}

void console_signal_handler(int signal)
{
	const char *signal_name;

	switch (signal) {
		case SIGTERM:
			signal_name = "SIGTERM";
			break;
		case SIGQUIT:
			signal_name = "SIGQUIT";
			break;
		case SIGINT:
			signal_name = "SIGINT";
			break;
		case SIGHUP:
			signal_name = "SIGHUP";
			break;
		default:
			signal_name = "UNKNOWN_SIGNAL";
			break;
	}

	printf("VIEWER_INFO: Received %s, exiting...\n", signal_name);

	exit(0);
}
