#include "event_queue.h"



int first = 0;
int last = 0;

struct event event_array[MAX_QUEUE_LENGTH] = {{0}};

int enqueue_event(struct event *e)
{
	int next = (last + 1) % MAX_QUEUE_LENGTH;

	if(next == first)
	{
		return 0;
	}
	else
	{
		event_array[last] = *e;

		int cur = last;
		int prev = (cur - 1) % MAX_QUEUE_LENGTH;

		while(cur != first && event_array[prev].time > event_array[cur].time)
		{
			struct event temp = event_array[prev];
			event_array[prev] = event_array[cur];
			event_array[cur] = temp;

			cur = prev;
			prev = (cur - 1) % MAX_QUEUE_LENGTH;
		}

		last = next;

		//printf("enqueued event sta: %d, typ: %d, time: %lu\n", e->station, e->type, e->time);

		return 1;
	}
}

int peek_event(struct event *e)
{
	if(first == last)
	{
		//printf("ERROR: Event Queue empty.");
		return 0;
	}
	else
	{
		*e = event_array[first];

		return 1;
	}
}

int dequeue_event(struct event *e)
{
	if(first == last)
	{
		//printf("ERROR: Event Queue empty.");
		return 0;
	}
	else
	{
		*e = event_array[first];
		first = (first + 1) % MAX_QUEUE_LENGTH;

		return 1;
	}
}

void print_queue()
{
	printf("(\n");
	int current = first;
	while(current != last)
	{
		printf("\t%ld,\n", event_array[current].time);
		current = (current + 1) % MAX_QUEUE_LENGTH;
	}
	printf(")\n");
}

long start;

struct timespec diff(struct timespec start, struct timespec end);

struct timespec diff(struct timespec start, struct timespec end)
{
	struct timespec temp;
	if ((end.tv_nsec-start.tv_nsec)<0) {
		temp.tv_sec = end.tv_sec-start.tv_sec-1;
		temp.tv_nsec = 1000000000+end.tv_nsec-start.tv_nsec;
	} else {
		temp.tv_sec = end.tv_sec-start.tv_sec;
		temp.tv_nsec = end.tv_nsec-start.tv_nsec;
	}
	return temp;
}

/*int main()
{
	struct timespec ts;
	clock_gettime(CLOCK_REALTIME, &ts);
	start = 1000000000L * ts.tv_sec + ts.tv_nsec;

	srand((unsigned) time(NULL));


	int i;
	for(i = 0; i < MAX_QUEUE_LENGTH / 2; ++i)
	{
		long l = start + 2000000000L + (((long)rand() << 32) | (long)rand()) % 30000000000;
		enqueue(l);
		enqueue(l + 1000);
	}

	print_queue();

	struct item due_item;
	dequeue(&due_item);

	long diff2 = 0;

	while(1)
	{
		clock_gettime(CLOCK_REALTIME, &ts);
		long current_time = 1000000000L * ts.tv_sec + ts.tv_nsec;
		if(current_time >= due_item.time)
		{
			diff2 = current_time - due_item.time > diff2 ? current_time - due_item.time : diff2;
			if(!dequeue(&due_item))
				break;
		}
	}

	printf("diff: %lu\n", diff2);

	return 0;
}*/
