/*
 * helper.c
 *
 *  Created on: Aug 3, 2014
 *      Author: andreas
 */



#include "helper.h"

long get_time_nsec()
{
	struct timespec ts;
  	clock_gettime(CLOCK_REALTIME, &ts);
	return 1000000000L * ts.tv_sec + ts.tv_nsec - time_program_launch;
}

void print_packet_buffer(void* buffer)
{

	Macframe *frame = (Macframe*) buffer;

	printf("(%lx) %2d -> %2d (%4d)", buffer, frame->header.srcAddr, frame->header.destAddr, frame->header.length);

	switch(frame->header.pktType)
	{
		case PACKET_TOKEN:
			printf("P_TOKEN\n");
			break;

		case PACKET_CLAIM_TOKEN:
			printf("P_CLAIM_TOKEN\n");
			break;

		case PACKET_SOLICIT_SUCCESSOR:
			printf("P_SOLICIT_SUCCESSOR\n");
			break;

		case PACKET_SET_PREDECESSOR:
			printf("P_SET_PREDECESSOR\n");
			break;

		case PACKET_SET_SUCCESSOR:
			printf("P_SET_SUCCESSOR\n");
			break;

		case PACKET_DATA:
			printf("PACKET_DATA\n");
			break;

		case PACKET_ACK:
			printf("PACKET_ACK\n");
			break;




		case PACKET_TOKEN_ACK:
			printf("PACKET_TOKEN_ACK\n");
			break;





		default:
			printf("%d\n", frame->header.pktType);
			break;
	}
}
