/*
 * station.h
 *
 *  Created on: Aug 2, 2014
 *      Author: andreas
 */

#ifndef STATION_H_
#define STATION_H_

#define _GNU_SOURCE

#include <stdlib.h>
#include <stdio.h>
#include <stdint.h>
#include <pty.h>
#include <termios.h>
#include <fcntl.h>
#include <signal.h>
#include <string.h>

#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>

#include "settings.h"

uint32_t station_id;

struct sockaddr_in station_ip_addr;
unsigned short station_udp_port;

int station_pty_fd;
FILE* station_pty_file;

int sockfd;

uint32_t *station_rx_header_indicator;
uint32_t *station_rx_payload_indicator;

uint32_t *station_tx_active_indicator;

uint32_t *station_rx_buffer_id;
uint32_t *station_tx_buffer_id;

void **station_packet_buffers;

uint32_t *station_left_button;
uint32_t *station_right_button;
uint32_t *station_up_button;
uint32_t *station_middle_button;

int station_led_low;
int station_led_high;

int station_left_hex;
int station_middle_hex;
int station_right_hex;

int station_main(int id);



#endif /* STATION_H_ */
